import { className, mergeData, renderRule } from '../../core/utils'
import rules from './layout.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String,
      default: 'div'
    },
    grow: {
      type: [ Number, String ]
    },
    shrink: {
      type: [ Number, String ]
    },
    basis: {
      type: [ Number, String ]
    },
    display: {
      type: String,
      default: null
    },
    wrap: {
      type: String
    },
    direction: {
      type: String
    },
    alignItem: {
      type: String
    },
    justifyItem: {
      type: String
    },
    alignItems: {
      type: String
    },
    justifyItems: {
      type: String
    }
  },
  render(h, ctx) {
    const classes = renderRule(ctx, rules.layout)
    return h(ctx.props.tag, mergeData(ctx, {
      class: className(ctx, 'layout', classes)
    }), ctx.children)
  }
}
