import { className, mergeData, renderRules } from '../../core/utils'
import Space from '../space/space'
import rules from './page.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String,
      default: 'div'
    },
    maxWidth: {
      type: Number,
      default: 1080
    }
  },
  render(h, ctx) {
    const classes = renderRules(ctx, rules)
    return h(Space, mergeData(ctx, {
      class: className(ctx, null, classes.space),
      props: {
        property: 'margin',
        desktop: true
      }
    }), [
      h(ctx.props.tag, {
        class: className(ctx, 'page', classes.page)
      }, ctx.children)
    ])
  }
}
