// import logger from 'fela-plugin-logger'
import monolithic from 'fela-monolithic'
import embedded from 'fela-plugin-embedded'
import prefixer from 'fela-plugin-prefixer'
import fallback from 'fela-plugin-fallback-value'
import placeholder from 'fela-plugin-placeholder-prefixer'
import pseudo from 'fela-plugin-friendly-pseudo-class'
import extend from 'fela-plugin-extend'
import lvha from 'fela-plugin-lvha'
import unit from 'fela-plugin-unit'
import customKeys from './custom-keys'
import aliasKeys from './alias-keys'

const createConfig = ({
  monolithic: useMonolithic = false,
  custom: customConfig = {},
  alias: aliasConfig = {},
  unit: unitConfig = []
} = {}) => ({
  enhancers: useMonolithic ? [
    monolithic()
  ] : null,
  // Order matters
  plugins: [
    extend(),
    pseudo(),
    aliasKeys(aliasConfig),
    customKeys(customConfig),
    placeholder(),
    embedded(),
    prefixer(),
    fallback(),
    lvha(),
    unit(...unitConfig)
  ]
})

export default createConfig
